/* Header for module geograph, generated by p2c */
#ifndef GEOGRAPH_H
#define GEOGRAPH_H


/*$f+*/

#ifndef GRAPH_H
#include "graph.h"
#endif


#ifdef GEOGRAPH_G
# define vextern
#else
# define vextern extern
#endif


/**************************/
/****  g e o g r a p h ****/
/**************************/

/*geoconst.pas:*/

#define array_size      10000   /*  < array_size in driver/g_const.h !!!!*/

#define pi              3.14159265358
#define pi2             6.2831853
#define pih             1.5707963
#define eps1            0.1
#define eps2            0.01
#define eps3            0.001
#define eps4            0.0001
#define eps5            0.00001
#define eps6            0.000001
#define eps7            0.0000001
#define eps8            0.00000001

#define default_        (-1)
#define black           0
#define blue            1
#define green           2
#define cyan            3
#define red             4
#define magenta         5
#define brown           6
#define lightgray       7
#define darkgray        8
#define lightblue       9
#define lightgreen      10
#define lightcyan       11
#define lightred        12
#define lightmagenta    13
#define yellow          14
#define white           15


/*C*/

/*geotype.pas:*/

typedef double r_array[array_size + 1];
typedef int i_array[array_size + 1];
typedef boolean b_array[array_size + 1];

typedef struct vt2d {
  double x, y;
} vt2d;

typedef struct vt3d {
  double x, y, z;
} vt3d;

typedef vt2d vts2d[array_size + 1];
typedef vt3d vts3d[array_size + 1];
typedef double matrix3d[3][3];


/*geovar.pas:*/

vextern vt2d null2d;
vextern vt3d null3d;   /*Nullvektoren*/

/***fuer area_2d and curve2d:*/
vextern vt2d origin2d;

/***fuer Parallel- und Zentral-Projektion:*/
vextern double u_angle, v_angle;   /*Projektionswinkel*/
vextern double rad_u, rad_v;   /*rad(u), rad(v)*/
vextern double sin_u, cos_u, sin_v, cos_v;   /*sin-,cos- Werte von u, v*/
vextern vt3d e1vt, e2vt, n0vt;   /*Basis-Vektoren*/
/*Normalen-Vektor der Bildebene*/
/***fuer Zentral-Projektion:*/
vextern vt3d mainpt;   /*Hauptpunkt*/
vextern vt3d centre;   /*Zentrum*/
vextern double distance;   /*Distanz Hauptpunkt-Zentrum*/


/*V*/
/*****************************/
/****  H E A D _ G E O    ****/
/*****************************/

extern void GeoInit(void);
extern void graph_on(int mode);
extern void draw_area(double width, double height, double x0, double y0, double sfac);
extern void draw_end(void);
extern void graph_off(void);
extern void new_color(int color);
extern void new_linewidth(double factor);
extern void linec2d(double x1, double y1, double x2, double y2, int style);
extern void line2d(vt2d p1, vt2d p2, int style);
extern void pointc2d(double x, double y, int style);
extern void point2d(vt2d p, int style);
extern void curve2d(vt2d *p, int n1, int n2, int style);
extern void curve2d_vis(vt2d *p, int n1, int n2, int style, boolean *visible);
extern void arrowc2d(double x1, double y1, double x2, double y2, int style);
extern void arrow2d(vt2d p1, vt2d p2, int style);
extern void read_integer_file(Char *file_name, int n_dat, int *int_var);
/*V*/
/************************************************/
/********** H E A D _ A G  **********************/
/**** Prozedur-Koepfe der Datei proc_ag.pas  ****/
/************************************************/

extern int sign(double a);
extern double max(double a, double b);
extern double min(double a, double b);
extern void change1d(double *a, double *b);
extern void change2d(vt2d *v1, vt2d *v2);
extern void change3d(vt3d *v1, vt3d *v2);
extern void put2d(double x, double y, vt2d *v);
extern void put3d(double x, double y, double z, vt3d *v);
extern void get3d(vt3d v, double *x, double *y, double *z);
extern void scale2d(double r, vt2d v, vt2d *vs);
extern void scale3d(double r, vt3d v, vt3d *vs);
extern void scaleco2d(double r1, double r2, vt2d v, vt2d *vs);
extern void scaleco3d(double r1, double r2, double r3, vt3d v, vt3d *vs);
extern void sum2d(vt2d v1, vt2d v2, vt2d *vs);
extern void sum3d(vt3d v1, vt3d v2, vt3d *vs);
extern void diff2d(vt2d v1, vt2d v2, vt2d *vs);
extern void diff3d(vt3d v1, vt3d v2, vt3d *vs);
extern void lcomb2vt2d(double r1, vt2d v1, double r2, vt2d v2, vt2d *vlc);
extern void lcomb2vt3d(double r1, vt3d v1, double r2, vt3d v2, vt3d *vlc);
extern void lcomb3vt2d(double r1, vt2d v1, double r2, vt2d v2, double r3, vt2d v3, vt2d *vlc);
extern void lcomb3vt3d(double r1, vt3d v1, double r2, vt3d v2, double r3, vt3d v3, vt3d *vlc);
extern void lcomb4vt3d(double r1, vt3d v1, double r2, vt3d v2, double r3, vt3d v3, double r4,
		       vt3d v4, vt3d *vlc);
extern double abs2d(vt2d v);
extern double abs3d(vt3d v);
extern double length2d(vt2d v);
extern double length3d(vt3d v);
extern double scalarp2d(vt2d p1, vt2d p2);
extern double scalarp3d(vt3d p1, vt3d p2);
extern void normalize2d(vt2d *p);
extern void normalize3d(vt3d *p);
extern double distance2d(vt2d p, vt2d q);
extern double distance3d(vt3d p, vt3d q);
extern double distance2d_square(vt2d p, vt2d q);
extern double distance3d_square(vt3d p, vt3d q);
extern void vectorp(vt3d v1, vt3d v2, vt3d *vp);
extern double determ3d(vt3d v1, vt3d v2, vt3d v3);
extern void rotor2d(double cos_rota, double sin_rota, vt2d p, vt2d *pr);
extern void rotp02d(double cos_rota, double sin_rota, vt2d p0, vt2d p, vt2d *pr);
extern void rotorz(double cos_rota, double sin_rota, vt3d p, vt3d *pr);
extern void rotp0z(double cos_rota, double sin_rota, vt3d p0, vt3d p, vt3d *pr);
extern void rotp0x(double cos_rota, double sin_rota, vt3d p0, vt3d p, vt3d *pr);
extern void rotp0y(double cos_rota, double sin_rota, vt3d p0, vt3d p, vt3d *pr);
extern void line_pts2d(vt2d p1, vt2d p2, vt2d *p, int *n2);
extern void line_pts3d(vt3d p1, vt3d p2, vt3d *p, int *n2);
extern double polar_angle(double x, double y);
extern void equation_degree1(double a, double b, double *x, int *ns);
extern void equation_degree2(double a, double b, double c, double *x1, double *x2, int *ns);
extern void is_line_line(double a1, double b1, double c1, double a2, double b2, double c2,
			 double *xs, double *ys, int *nis);
extern void is_unitcircle_line(double a, double b, double c, double *x1, double *y1, double *x2,
			       double *y2, int *nis);
extern void is_circle_line(double xm, double ym, double r, double a, double b, double c, double *x1,
			   double *y1, double *x2, double *y2, int *nis);
extern void is_circle_circle(double xm1, double ym1, double r1, double xm2, double ym2, double r2,
			     double *x1, double *y1, double *x2, double *y2, int *nis);
extern boolean pt_before_plane(vt3d p, vt3d nv, double d);
extern void plane_equ(vt3d p1, vt3d p2, vt3d p3, vt3d *nv, double *d, boolean *error);
extern void is_line_plane(vt3d p, vt3d rv, vt3d nv, double d, vt3d *pis, int *nis);
extern void is_3_planes(vt3d nv1, double d1, vt3d nv2, double d2, vt3d nv3, double d3, vt3d *pis,
			boolean *error);
extern void is_plane_plane(vt3d nv1, double d1, vt3d nv2, double d2, vt3d *p, vt3d *rv,
			   boolean *error);
extern void ptco_plane3d(vt3d p0, vt3d v1, vt3d v2, vt3d p, double *xi, double *eta, boolean *error);
/*V*/
/*************************/
/****  H E A D _ P P  ****/
/*************************/

extern void init_parallel_projection(void);
extern void pp_vt3d_vt2d(vt3d p, vt2d *pp);
extern void pp_point(vt3d p, int style);
extern void pp_line(vt3d p1, vt3d p2, int style);
extern void pp_arrow(vt3d p1, vt3d p2, int style);
extern void pp_axes(double al);
extern void pp_vts3d_vts2d(vt3d *p, int n1, int n2, vt2d *pp);
extern void pp_curve(vt3d *p, int n1, int n2, int style);
extern void pp_curve_vis(vt3d *p, int n1, int n2, int style, boolean *visible);
extern void pp_line_before_plane(vt3d p1, vt3d p2, vt3d nv, double d, int side, int style);
extern void pp_curve_before_plane(vt3d *p, int n1, int n2, vt3d nv, double d, int side, int style);
/*V*/
/**************************/
/****   H E A D _ K S  ****/
/**************************/

/*** A: Kegelschnitte in 2D ****/

extern void ellipse_pts2d(vt2d p0, vt2d p1, vt2d p2, double t3, double t4, vt2d *p, int *n2);
extern void ellipse_arc2d(vt2d p0, vt2d p1, vt2d p2, double t3, double t4, int style);
extern void circle_arc2d(double xm, double ym, double r, double t1, double t2, int style);
extern void ellipse_arc2d_ax(double xm, double ym, double a, double b, double w, double t1,
			     double t2, int style);
extern void ellipse2d_ax(double xm, double ym, double a, double b, double w, int style);
extern double sinh_(double t);
extern double cosh_(double t);
extern void hyperb_pts2d(vt2d p0, vt2d p1, vt2d p2, double t3, double t4, int ia, vt2d *p, int *n2);
extern void hyperb_arc2d(vt2d p0, vt2d p1, vt2d p2, double t3, double t4, int ia, int style);
extern void hyperb_arc2d_ax(double xm, double ym, double a, double b, double w, double t1,
			    double t2, int ia, int style);
extern void parab_pts2d(vt2d p0, vt2d p1, vt2d p2, double t3, double t4, vt2d *p, int *n2);
extern void parab_arc2d(vt2d p0, vt2d p1, vt2d p2, double t3, double t4, int style);
extern void parab_arc2d_ax(double a, double x0, double y0, double w, double t1, double t2,
			   int style);
/**********************************/
/**** B:  Kegelschnitte in 3D  ****/
/**********************************/
extern void ellipse_pts3d(vt3d p0, vt3d p1, vt3d p2, vt3d p3, vt3d p4, vt3d *p, int *n2);
extern void ellipse_pts3d_t3t4(vt3d p0, vt3d p1, vt3d p2, double t3, double t4, vt3d *p, int *n2);
extern void circle_pts3d(vt3d p0, vt3d nv, double r, vt3d *p, int *n2);
extern void is_ellipse_plane(vt3d pc0, vt3d pc1, vt3d pc2, vt3d nv, double d, vt3d *q1, vt3d *q2,
			     int *nis);
extern void hyperb_pts3d(vt3d p0, vt3d p1, vt3d p2, vt3d p3, vt3d p4, vt3d *p, int *n2);
extern void parab_pts3d(vt3d p0, vt3d p1, vt3d p2, vt3d p3, vt3d p4, vt3d *p, int *n2);
/*V*/
/************************************/
/********  H E A D _ P K S  *********/
/************************************/

extern void pp_ellipse_arc(vt3d p0, vt3d p1, vt3d p2, vt3d p3, vt3d p4, int style);
extern void pp_ellipse(vt3d p0, vt3d p1, vt3d p2, int style);
extern void pp_ellipse_before_plane(vt3d pc0, vt3d pc1, vt3d pc2, vt3d nv, double d, int side,
				    int style);
extern void cone_pp_cont0(double h, double r, vt3d *p1, vt3d *p2, boolean *contlines);
extern void pp_hyperb_arc(vt3d p0, vt3d p1, vt3d p2, vt3d p3, vt3d p4, int style);
extern void pp_parab_arc(vt3d p0, vt3d p1, vt3d p2, vt3d p3, vt3d p4, int style);
/*V*/
/*************************/
/****  H E A D _ Q U A  ****/
/*************************/

extern void is_cylinder_plane(vt3d q0, vt3d q1, vt3d q2, vt3d q3, vt3d nv, double d, vt3d *pc0,
			      vt3d *pc1, vt3d *pc2, int *ind);
extern void is_unitcone_plane0(double a, double c, double d, vt3d *p0, vt3d *p1, vt3d *p2, int *ind);
extern void is_unitcone_plane(double a, double b, double c, double d, vt3d *p0, vt3d *p1, vt3d *p2,
			      int *ind);
extern void is_cone_plane(vt3d q0, vt3d q1, vt3d q2, vt3d peak, vt3d nv, double d, vt3d *pc0,
			  vt3d *pc1, vt3d *pc2, int *ind);
extern void is_cone_plane1(double h, double r, double a, double c, double d, vt3d *p0, vt3d *p1,
			   vt3d *p2, int *ind);
extern void is_sphere_plane(vt3d pm, double r, vt3d nv, double d, vt3d *pc0, vt3d *pc1, vt3d *pc2,
			    int *nis);
extern void is_unitsphere_plane(double a, double b, double c, double d, vt3d *pc0, vt3d *pc1,
				vt3d *pc2, int *nis);
extern void is_ellipsoid_plane(vt3d q0, vt3d q1, vt3d q2, vt3d q3, vt3d nv, double d, vt3d *pc0,
			       vt3d *pc1, vt3d *pc2, int *nis);
extern void is_hyperboloid_plane0(double a, double c, double d, vt3d *pc0, vt3d *pc1, vt3d *pc2,
				  int *ind);
extern void is_unithyperboloid_plane(double a, double b, double c, double d, vt3d *p0, vt3d *p1,
				     vt3d *p2, int *ind);
extern void is_hyperboloid_plane(vt3d q0, vt3d q1, vt3d q2, vt3d q3, vt3d nv, double d, vt3d *pc0,
				 vt3d *pc1, vt3d *pc2, int *ind);
extern void is_hyperboloid_plane1(double rx, double ry, double rz, vt3d nv, double d, vt3d *pc0,
				  vt3d *pc1, vt3d *pc2, int *ind);
extern void is_paraboloid_plane0(double a, double c, double d, vt3d *pc0, vt3d *pc1, vt3d *pc2,
				 int *ind);
extern void is_paraboloid_plane1(double rx, double ry, vt3d nv, double d, vt3d *pc0, vt3d *pc1,
				 vt3d *pc2, int *ind);
extern void is_paraboloid_plane2(double ap, vt3d nv, double d, vt3d *pc0, vt3d *pc1, vt3d *pc2,
				 int *ind);
extern void is_unitparaboloid_plane(double a, double b, double c, double d, vt3d *pc0, vt3d *pc1,
				    vt3d *pc2, int *ind);
extern void is_paraboloid_plane(vt3d q0, vt3d q1, vt3d q2, vt3d q3, vt3d nv, double d, vt3d *pc0,
				vt3d *pc1, vt3d *pc2, int *ind);
/*V*/
/**************************/
/****  H E A D _ P Q U  ****/
/*************************/

extern void ellipsoid_pp_cont(vt3d q0, vt3d q1, vt3d q2, vt3d q3, vt3d *qc0, vt3d *qc1, vt3d *qc2);
extern void pp_ellipsoid(vt3d q0, vt3d q1, vt3d q2, vt3d q3);
extern void paraboloid_pp_cont(vt3d q0, vt3d q1, vt3d q2, vt3d q3, vt3d *qc0, vt3d *qc1, vt3d *qc2);
extern void pp_paraboloid_rev(double a, double h, int style);
extern void hyperboloid_pp_cont(vt3d q0, vt3d q1, vt3d q2, vt3d q3, vt3d *qc0, vt3d *qc1, vt3d *qc2,
				int *ind);
extern void pp_hyperboloid_rev(double a, double c, double z1, double z2, int style);
extern void cylinder_pp_contpts(vt3d q0, vt3d q1, vt3d q2, vt3d q3, vt3d *qc1, vt3d *qc2,
				vt3d *qc11, vt3d *qc22, boolean *contlines);
extern void pp_cylinder(vt3d q0, vt3d q1, vt3d q2, vt3d q3, int style);
extern void pp_cylinder_orth(vt3d q0, vt3d q1, vt3d q2, double clength, int style);
extern void cone_pp_contpts(vt3d q0, vt3d q1, vt3d q2, vt3d peak, vt3d *qc1, vt3d *qc2,
			    boolean *contlines);
extern void pp_cone(vt3d q0, vt3d q1, vt3d q2, vt3d peak, int style);
extern void pp_cone_orth(vt3d p0, vt3d p1, vt3d p2, double clength, int style);
/*V*/
/*********************************/
/******  H E A D _ Z P      ******/
/******  Zentralprojektion  ******/
/******  OHNE Clipping      ******/
/*********************************/

extern void init_central_projection(void);
/****************/

extern void init_centralparallel_projection(int ind);
/****************/

extern void transf_to_e1e2n0_base(vt3d p, vt3d *pm);
/*****************/

extern void cp_vt3d_vt2d(vt3d p, vt2d *pp);
/****************/

extern void cp_point(vt3d p, int style);
/***************/

extern void cp_line(vt3d p1, vt3d p2, int style);
/***************/

extern void cp_arrow(vt3d p1, vt3d p2, int style);
/***************/

extern void cp_axes(double al);
/***************/

extern void cp_vts3d_vts2d(vt3d *p, int n1, int n2, vt2d *pp);
/***************/

extern void cp_curve(vt3d *p, int n1, int n2, int style);
/***************/

extern void cp_curve_vis(vt3d *p, int n1, int n2, int style, boolean *visible);
/***************/


extern void cp_line_before_plane(vt3d p1, vt3d p2, vt3d nv, double d, int side, int style);
/****************/

extern void cp_curve_before_plane(vt3d *p, int n1, int n2, vt3d nv, double d, int side, int style);
/***************/
/*V*/


#undef vextern

#endif /*GEOGRAPH_H*/

/* End. */
