/* Header for module hiddenl, generated by p2c */
#ifndef HIDDENL_H
#define HIDDENL_H


/*$f+*/

#ifndef GRAPH_H
#include "graph.h"
#endif

#ifndef GEOGRAPH_H
#include "geograph.h"
#endif


#ifdef HIDDENL_G
# define vextern
#else
# define vextern extern
#endif


/**************************/
/****  h i d d e n l ****/
/**************************/

/*fuer Hiddenline:*/

/*Achtung: es muss  array_size>=nfmax  sein  !!!*/

#define nfmax           10000
#define nemax           20000
#define nsegmax         10
#define npfmax          10


typedef vt2d vts2d_pol[npfmax + 1];
typedef vt3d vts3d_pol[npfmax + 1];
typedef double r_array_seg[nsegmax + 1];
typedef int i_array_seg[nsegmax + 1];

typedef struct box3d_dat {
  double xmin, xmax, ymin, ymax, zmin, zmax;
} box3d_dat;

typedef struct face_dat {
  int npf, nef;
  int fp[npfmax], fe[npfmax];
  boolean vis;
  box3d_dat box;
  double discentre, d;
  vt3d nv;
} face_dat;

typedef struct edge_dat {
  boolean vis;
  int ep1, ep2;
} edge_dat;


vextern int ne, nf, np;   /*Anzahl der Kanten, Facetten,Punkte*/
vextern vts3d p;   /*Punkte des Polyeders*/
vextern face_dat face[nfmax];
vextern edge_dat edge[nemax];
vextern r_array pdist;   /*pdist[i]: Abstand d. i-ten Punktes von d. Bildeb.*/
vextern boolean error, oriented_faces, is_permitted;


/*******************/
/****  HEAD_ZPO ****/
/*******************/

extern void aux_polyhedron(void);
extern void cp_vts3d_vts2d_spez(vt3d *p, int n1, int n2, vt2d *pp, double *pdist);
extern void aux_quadrangle(int n1, int n2, int np0, int ne0, int nf0);
extern void aux_quadrangle_triang(int n1, int n2, boolean show_triangles);
extern void aux_cylinder(int n1, int n2, int np0, int ne0, int nf0);
extern void aux_torus(int n1, int n2, int np0, int ne0, int nf0);
extern void is_line_convex_polygon(vt2d p1, vt2d p2, vt2d *p_pol, int np, double *t1, double *t2,
				   int *ind);
extern void intmint(double a, double b, double c, double d, double *e1, double *f1, double *e2,
		    double *f2, int *ind);
extern void cp_lines_before_convex_faces(boolean oriented_faces, boolean is_permitted);
extern void is_interv_interv(double *a, double *b, double *c, double *d, double *aa, double *bb,
			     boolean *inters);
extern void box3d_of_pts(vt3d *p, int np, box3d_dat *box);
extern boolean is_two_boxes3d(box3d_dat *box1, box3d_dat *box2);
extern void is_line_conv_pol_in_plane3d(vt3d *pl, vt3d *rl, vt3d *pp, int npp, double *t1,
					double *t2, boolean *inters);
extern void is_n1gon_n2gon3d(vt3d *pp1, vt3d *pp2, int np1, int np2, vt3d *ps1, vt3d *ps2,
			     boolean *intersection);
extern void boxes_of_faces(void);
extern void is_face_face(int i, int k, vt3d *ps1, vt3d *ps2, boolean *intersection);


#undef vextern

#endif /*HIDDENL_H*/

/* End. */
